﻿
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;
using System.Threading.Tasks;
using Wisej.Web;

namespace WebApplication2
{
    public partial class Window1 : Form
    {
        public static int FrameCount = 0;
        public static int GlobalHeight;
        public static int GlobalWidth;
        public static Random rand = new Random();
        private List<Stream> streams = new List<Stream>();
        private MatrixStreams ms;
        public Window1()
        {
            InitializeComponent();

            Window1.GlobalHeight = this.Size.Height;
            Window1.GlobalWidth = this.Size.Width;
            //var x = 0;
            //for (var i = 0; i <= this.Width / Stream.symbolSize; i++)
            //{
            //    var stream = new Stream(this);
            //    stream.generateSymbols(x, rand.Next(-2000, 0));
            //    streams.Add(stream);
            //    x += Stream.symbolSize;
            //}
            ms = new MatrixStreams();
            ms.Dock = DockStyle.Fill;
            this.Controls.Add(ms);
            ms.Update();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            try
            {
                //ms.Refresh();
                ms.Update();
                FrameCount++;
                //Draw();
                //Application.Update(this);
            }
            catch { }
        }

        private void Window1_Load(object sender, EventArgs e)
        {
            timer1.Start();            
        }

        private void Window1_SizeChanged(object sender, EventArgs e)
        {
            Window1.GlobalHeight = this.Size.Height;
            Window1.GlobalWidth = this.Size.Width;
        }
    }

    public class Symbol
    {
        private int Speed;
        public int Opacity;
        private int SwitchInterval = 5;
        public bool IsFirst { get; set; }
        public Point Location { get; private set; }
        public Color ForeColor { get; set; }
        public Size Size { get; private set; }
        public Font Font { get; private set; }
        public string Value { get; private set; }

        public Symbol(int x, int y, int speed, bool isFirst, int opacity)
        {
            this.SwitchInterval = Window1.rand.Next(2, 25);
            this.ForeColor = Color.FromArgb(0, 255, 70);
            this.Location = new Point(x, y);
            this.Speed = speed;
            this.Opacity = opacity;
            this.Size = new Size(32, 32);
            this.Font = new Font("Consolas", Stream.symbolSize);
            this.IsFirst = isFirst;
        }

        public void SetToRandomSymbol()
        {
            var frameCount = Window1.FrameCount;
            var charType = Window1.rand.Next(0, 5);
            if (frameCount % this.SwitchInterval == 0)
            {
                if (charType > 1)
                {
                    int charCode = 0x30A0;
                    charCode += Window1.rand.Next(0, 96);
                    string c = Char.ConvertFromUtf32(charCode);
                    this.Value = c;
                }
                else
                {
                    // set it to numeric
                    this.Value = Window1.rand.Next(0, 9).ToString();
                }
            }
        }

        public void Rain()
        {
            this.Location = new Point(this.Location.X, (this.Location.Y >= Window1.GlobalHeight) ? 0 : this.Location.Y + this.Speed);
        }        
    }

    public class Stream
    {
        public static double fadeInterval = 1.6;
        public static int symbolSize = 14;
        private List<Symbol> symbols = new List<Symbol>();
        private int TotalSymbols;
        private int Speed = 0;
        public Stream()
        {
            this.TotalSymbols = Window1.rand.Next(5, 35);
            this.Speed = Window1.rand.Next(5, 22);
        }

        public void generateSymbols(int x, int y)
        {
            var opacity = 255;
            var first = Window1.rand.Next(0, 4) == 1;
            for (var i = 0; i <= this.TotalSymbols; i++)
            {
                var symbol = new Symbol(
                  x,
                  y,
                  this.Speed,
                  first,
                  opacity
                );
                symbol.SetToRandomSymbol();
                this.symbols.Add(symbol);
                opacity -= (int)((255 / this.TotalSymbols) / fadeInterval);
                y -= symbolSize;
                first = false;
            }
        }

        public void Render(NativeTextRenderer render)
        {
            foreach (var symbol in symbols)
            {
                if (symbol.IsFirst)
                {
                    symbol.ForeColor = Color.FromArgb(symbol.Opacity, 140, 255, 170);
                }
                else
                {
                    symbol.ForeColor = Color.FromArgb(symbol.Opacity, 0, 255, 70);
                }
                render.DrawString(symbol.Value, symbol.Font, symbol.ForeColor, symbol.Location);
                symbol.Rain();
                symbol.SetToRandomSymbol();
            }
        }
    }
}
